export declare class DepGraph<T> {
    private readonly nodeByName;
    readonly rootNode: DepNode<T>;
    constructor();
    addDep(from: string, to: string): void;
    addDepToNode(fromNode: DepNode<T>, to: string, label?: string): DepNode<T>;
    lookup(name: string): DepNode<T> | undefined;
    getNode(name: string): DepNode<T>;
}
export declare class DepNode<T> {
    readonly name: string;
    private readonly edges;
    data: T | null;
    constructor(name: string);
    add(child: DepNode<T>, label?: string): void;
    dfs(approver?: (n: DepNode<T>) => boolean): DepNode<T>[];
}
