import { Instrument, Definition, Section, Bigband } from "bigband-core";
import { ResolvedName } from "./ResolvedName";
export declare class Namer {
    private readonly bigband;
    private readonly section;
    private readonly accountId;
    constructor(bigband: Bigband, section: Section, accountId: string);
    physicalName(instrument: Instrument): string;
    path(instrument: Instrument): string;
    resolve(instrument: Instrument): ResolvedName;
    /**
     * Computes the physical name of the given instrument. The physical name contains the names of the
     * enclosing bigband and section as well as the fully-qualified-name of the instrument.
     * @param instrument
     */
    getPhysicalDefinition(instrument: Instrument): Definition;
}
