import { AwsFactory, DeployableFragment } from 'bigband-core';
import { S3BlobPool } from './Teleporter';
import { S3Ref } from './S3Ref';
import { ZipBuilder } from './ZipBuilder';
import { ResolvedName } from './ResolvedName';
export declare enum DeployMode {
    ALWAYS = 1,
    IF_CHANGED = 2
}
export interface PushResult {
    deployableLocation: S3Ref;
    wasPushed: boolean;
    existed: boolean;
}
export declare class Packager {
    private readonly rootDir;
    private readonly awsFactory;
    private readonly blobPool;
    private readonly fragment;
    private readonly workingDir;
    private workingDirCreated;
    private readonly npmPackageDir;
    constructor(rootDir: string, npmPackageDir: string, awsFactory: AwsFactory, blobPool: S3BlobPool, fragment: DeployableFragment);
    private compile;
    private createZip;
    run(relativeTsFile: string, relativeOutDir: string, npmPackageName: string, nameInSection: string): Promise<ZipBuilder>;
    unzip(zipBuilder: ZipBuilder, relativeOutDir: string): string;
    pushToS3(name: ResolvedName, deployableLocation: S3Ref, zipBuilder: ZipBuilder, teleportLambdaName: string, teleportingEnabled: boolean, deployMode: DeployMode, printMessage: boolean): Promise<PushResult>;
    private toAbs;
    private newOutDir;
}
