/// <reference types="node" />
import { AwsFactory } from 'bigband-core';
export declare class S3Ref {
    readonly s3Bucket: string;
    readonly s3Key: string;
    constructor(s3Bucket: string, s3Key: string);
    static EMPTY: S3Ref;
    isOk(): boolean;
    toUri(): string;
    toString(): string;
    toPojo(): {
        bucket: string;
        key: string;
    };
    static put(factory: AwsFactory, s3Ref: S3Ref, buf: Buffer, contentType?: string): Promise<void>;
    static get(factory: AwsFactory, s3Ref: S3Ref): Promise<Buffer>;
    static getRegion(factory: AwsFactory, bucketName: string): Promise<string>;
    static exists(factory: AwsFactory, s3Ref: S3Ref): Promise<boolean>;
}
