/// <reference types="node" />
import { S3Ref } from "./S3Ref";
import { ZipBuilder } from "./ZipBuilder";
import { AwsFactory } from 'bigband-core';
declare type BlobPoolHandle = string;
interface PutResult {
    handle: BlobPoolHandle;
    bytesSent: number;
}
export declare class S3BlobPool {
    readonly factory: AwsFactory;
    private readonly s3Bucket;
    private readonly s3Prefix;
    constructor(factory: AwsFactory, s3Bucket: string, s3Prefix: string);
    put(buf: Buffer): Promise<PutResult>;
    get(handle: BlobPoolHandle): Promise<Buffer>;
    handleToS3Ref(handle: BlobPoolHandle): S3Ref;
}
export declare class Teleporter {
    private readonly blobPool;
    private numBytes;
    constructor(blobPool: S3BlobPool);
    readonly bytesSent: number;
    uploadFragments(zipBuilder: ZipBuilder): Promise<BlobPoolHandle[]>;
    private mergeFragments;
    nonIncrementalTeleport(zipBuilder: ZipBuilder, destination: S3Ref): Promise<number>;
    teleport(zipBuilder: ZipBuilder): Promise<S3Ref[]>;
}
export {};
